// (C) 2001-2010 Altera Corporation. All rights reserved.
// Your use of Altera Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License Subscription 
// Agreement, Altera MegaCore Function License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2010 Altera Corporation. All rights reserved.
// Your use of Altera Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License Subscription 
// Agreement, Altera MegaCore Function License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


module sv_10gbaser_xcvr #(
	parameter num_channels = 4,
	parameter operation_mode = "duplex",
	parameter sys_clk_in_mhz = 50,
	parameter reconfig_interfaces = 1,
	parameter gui_control_pin_out = 0,
	parameter ref_clk_freq = "322.265625 Mhz"
)(
	input  wire        mgmt_clk,            //         mgmt_clk.clk
	input  wire        mgmt_clk_rstn,    //     mgmt_clk_rst.reset_n
	input  wire        mgmt_read,           //         phy_mgmt.read
	input  wire        mgmt_write,          //                 .write
	input  wire [7:0] mgmt_address,        //                 .address
	input  wire [31:0] mgmt_writedata,      //                 .writedata
	output wire [31:0] mgmt_readdata,       //                 .readdata
	output wire        mgmt_waitrequest,    //                 .waitrequest
	input  wire        xgmii_tx_clk,        //     xgmii_tx_clk.clk
	input  wire        pll_ref_clk,         //      pll_ref_clk.clk
	output wire        xgmii_rx_clk,        //     xgmii_rx_clk.clk
	input  wire        rx_oc_busy,			// RX channel offset cancellation status
	output wire        tx_ready,           //         tx_ready.data
	output wire        rx_ready,          //        rx_ready0.data
	output wire        [num_channels -1 : 0]block_lock,		
	output wire        [num_channels -1 : 0]hi_ber,		
	output wire        [num_channels -1 : 0]pcs_status,		
	input  wire [72*num_channels -1 : 0] xgmii_tx_dc,      //    xgmii_tx_dc_0.data
	output wire [72*num_channels -1 : 0] xgmii_rx_dc,      //    xgmii_rx_dc_0.data
	output wire [num_channels -1 : 0] tx_serial_data, // tx_serial_data_0.export
	input  wire [num_channels -1 : 0] rx_serial_data  // rx_serial_data_0.export
	);
wire [num_channels -1 : 0]xgmii_rx_clk_wire;		
wire [num_channels -1 : 0]pll_is_locked;		
wire [num_channels -1 : 0]rx_is_lockedtodata;
wire [num_channels -1 : 0]rx_is_lockedtoref;
wire reset_controller_pll_powerdown;
wire reset_controller_tx_digitalreset;
wire reset_controller_rx_analogreset;
wire reset_controller_rx_digitalreset;

wire [31:0] pcs_mgmt_readdata;       //                 .readdata
wire [31:0] common_mgmt_readdata;       //                 .readdata

wire [num_channels -1 : 0]clr_errblk_cnt;		
wire [num_channels -1 : 0]clr_ber_cnt;		
wire [num_channels -1 : 0]block_lock_wire;		
wire [num_channels -1 : 0]hi_ber_wire;		
wire [num_channels -1 : 0]pcs_status_wire;		
wire [num_channels -1 : 0]tx_fifo_full;		
wire [num_channels -1 : 0]rx_fifo_full;		
wire [num_channels * 5 -1 : 0]ber_cnt;		
wire [num_channels * 7 -1 : 0]errored_block_cnt;		
wire [num_channels -1 : 0]rx_sync_head_error;		
wire [num_channels -1 : 0]rx_scrambler_error;		

assign block_lock = block_lock_wire;		
assign hi_ber = hi_ber_wire;		
assign pcs_status = pcs_status_wire;		

wire [num_channels -1 : 0] csr_pll_powerdown;
wire [num_channels -1 : 0] csr_tx_digitalreset;
wire [num_channels -1 : 0] csr_rx_analogreset;
wire [num_channels -1 : 0] csr_rx_digitalreset;
wire [num_channels -1 : 0] csr_reset_tx_digital;
wire [num_channels -1 : 0] csr_reset_rx_digital;
wire csr_reset_all ;		// power-up to 1 to trigger auto-init sequence
assign xgmii_rx_clk = xgmii_rx_clk_wire[0];		
genvar i;
generate 
	for(i = 0; i < num_channels; i = i + 1) 
	begin: ch
		sv_10gbaser_ch #(
			.operation_mode(operation_mode),
		//	.reconfig_interfaces(reconfig_interfaces),
			.output_clock_frequency ("5156.25 MHz"),
			.ref_clk_freq(ref_clk_freq)
		)sv_10gbaser_ch_inst(
			.pll_ref_clk(pll_ref_clk),         //      pll_ref_clk.clk
			.xgmii_tx_clk(xgmii_tx_clk),        //     xgmii_tx_clk.clk
			.xgmii_rx_clk(xgmii_rx_clk_wire),
			.tx_digital_rstn(!csr_tx_digitalreset[i]),
			.tx_analog_rst(csr_pll_powerdown),
			.rx_digital_rstn(!csr_rx_analogreset[i]),
			.rx_analog_rstn(!csr_rx_digitalreset[i]),
			.pll_rstn(!csr_pll_powerdown),
			.xgmii_tx_dc(xgmii_tx_dc[(i + 1) * 72 -1 : i *72]),      //    xgmii_tx_dc_0.data
			.xgmii_rx_dc(xgmii_rx_dc[(i + 1) * 72 -1 : i *72]),      //    xgmii_rx_dc_0.data
			.tx_serial_data(tx_serial_data[i]), // tx_serial_data_0.export
			.rx_serial_data(rx_serial_data[i]),  // rx_serial_data_0.export
			.rx_is_lockedtodata(rx_is_lockedtodata[i]),          //        rx_ready0.data
			.rx_is_lockedtoref(rx_is_lockedtoref[i]),          //        rx_ready0.data
			.pll_locked(pll_is_locked[i]),          //        rx_ready0.data
		
			.rxclrerrorblockcount(clr_errblk_cnt[i]),
			.rxclrbercount(clr_ber_cnt[i]),
			.pcsstatus(pcs_status_wire[i]),
			.rxblocklock(block_lock_wire[i]),
			.rxhighber(hi_ber_wire[i]),
			.bercount(ber_cnt[(i + 1) * 5 -1 : i *5]),
			.errorblockcount(errored_block_cnt[(i + 1) * 7 -1 : i *7]),
			.rxfifofull(rx_fifo_full[i]),
			.rxsyncheadererror(rx_sync_head_error[i]),
			.rxscramblererror(rx_scrambler_error[i]),
			.txfifofull(tx_fifo_full[i])
		);
	end
endgenerate

alt_reset_ctrl_tgx_cdrauto
#(
	.sys_clk_in_mhz (sys_clk_in_mhz)	// needed for 1us and 4us delay timers
)reset_control (
	// User inputs and outputs
	.clock(mgmt_clk),
	.reset_all( csr_reset_all),
	.reset_tx_digital(csr_reset_tx_digital),
	.reset_rx_digital(csr_reset_rx_digital),
	.powerdown_all(mgmt_clk_rstn),
	.tx_ready(tx_ready),
	.rx_ready(rx_ready),
	
	// I/O to Stratix IV transceiver control & status
	.pll_powerdown(reset_controller_pll_powerdown),		// reset TX PLL
	.tx_digitalreset(reset_controller_tx_digitalreset),	// reset TX PCS
	.rx_analogreset(reset_controller_rx_analogreset),		// reset RX PMA
	.rx_digitalreset(reset_controller_rx_digitalreset),	// reset RX PCS
//	.gxb_powerdown(gxb_powerdown),		// powerdown whole quad
	.pll_is_locked(pll_is_locked[0]),		// TX PLL is locked status
	.rx_oc_busy(rx_oc_busy),			// RX channel offset cancellation status
	.rx_is_lockedtodata(rx_is_lockedtodata)	// RX CDR PLL is locked to refclk status
);

sv_generic_csr #(
	.lanes (num_channels),
	.plls (1)
)generic_csr
(
	// user data (avalon-MM formatted) 
	.clk(mgmt_clk),
	.reset(mgmt_clk_rstn),
	.address(mgmt_address),
	.read(mgmt_read),
	.readdata (common_mgmt_readdata),
	.write(mgmt_write),
	.writedata(mgmt_writedata),

	// transceiver status inputs to this CSR
	.pll_locked(pll_is_locked[0]),
	.rx_is_lockedtoref(rx_is_lockedtoref),
	.rx_is_lockedtodata(rx_is_lockedtodata),
//	.rx_signaldetect(rx_signaldetect),
	
	// reset controller outputs
	.reset_controller_tx_ready(tx_ready),
	.reset_controller_rx_ready(rx_ready),
	.reset_controller_pll_powerdown(reset_controller_pll_powerdown),
	.reset_controller_tx_digitalreset(reset_controller_tx_digitalreset),
	.reset_controller_rx_analogreset(reset_controller_rx_analogreset),
	.reset_controller_rx_digitalreset(reset_controller_rx_digitalreset),

	// read/write control registers
	// to reset controller
	.csr_reset_tx_digital(csr_reset_tx_digital),
	.csr_reset_rx_digital(csr_reset_rx_digital),
	.csr_reset_all (csr_reset_all),		// power-up to 1 to trigger auto-init sequence
	// to PMA and PCS reset inputs
	.csr_pll_powerdown(csr_pll_powerdown),  	// reset controller or manual
	.csr_tx_digitalreset(csr_tx_digitalreset),	// reset controller or manual
	.csr_rx_analogreset(csr_rx_analogreset), 	// reset controller or manual
	.csr_rx_digitalreset(csr_rx_digitalreset)	// reset controller or manual
	// common PMA controls
/*	output	reg  [lanes - 1 : 0]	csr_phy_loopback_serial = 0,
	output	reg  [lanes - 1 : 0]	csr_tx_invpolarity = 0,
	output	reg  [lanes - 1 : 0]	csr_rx_invpolarity = 0,
	output	reg  [lanes - 1 : 0]	csr_rx_set_locktoref = 0,
	output	reg  [lanes - 1 : 0]	csr_rx_set_locktodata = 0*/
);

csr_pcs10gbaser #(
	.lanes( num_channels)
)pcs_map(
	// user data (avalon-MM formatted) 
	.clk(mgmt_clk),
	.reset(!mgmt_clk_rstn),
	.address(mgmt_address),
	.read(mgmt_read),
	.readdata(pcs_mgmt_readdata),
	.write(mgmt_write),
	.writedata(mgmt_writedata),

	.rx_clk(xgmii_rx_clk),	// to synchronize rx control outputs
	.tx_clk(xgmii_rx_clk),	// to synchronize tx control outputs


	//transceiver status inputs to this CSR
	.pcs_status         (pcs_status_wire),
	.hi_ber             (hi_ber_wire),
	.block_lock         (block_lock_wire),
	.tx_fifo_full       (tx_fifo_full),
	.rx_fifo_full       (rx_fifo_full),
	.rx_sync_head_error (rx_sync_head_error),
	.rx_scrambler_error (rx_scrambler_error),
	.ber_cnt            (ber_cnt),
	.errored_block_cnt(errored_block_cnt),

	
	// read/write control outputs
	// PCS controls
	.csr_rclr_errblk_cnt(clr_errblk_cnt),
	.csr_rclr_ber_cnt(clr_ber_cnt)
);

assign enable_pcs = mgmt_address[7];//200 shift 2 bits at the lsb

assign mgmt_readdata = (enable_pcs & pcs_mgmt_readdata) | (!enable_pcs & common_mgmt_readdata);
endmodule