# (C) 2001-2010 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Altera Program License Subscription 
# Agreement, Altera MegaCore Function License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Altera and sold by 
# Altera or its authorized distributors.  Please refer to the applicable 
# agreement for further details.



# +-----------------------------------
# | 
# | sv_10gbaser_xcvr "SV 10GBase-R Transiver" 
# | Jinyan Zhang
# | sv_10gbaser_xcvr
# | 
# | ../sv/sv_10gbaser_xcvr.v
# | 
# +-----------------------------------

# +-----------------------------------
# | request TCL package from ACDS 9.1
# | 
package require -exact sopc 9.1
# | 
# +-----------------------------------

# +-----------------------------------
# | module sv_10gbaser_xcvr
# | 
set_module_property DESCRIPTION "SV 10GBase-R Transiver"
set_module_property NAME sv_10gbaser_xcvr
set_module_property VERSION 10.0
set_module_property INTERNAL true
set_module_property GROUP "Interface Protocols/Ethernet"
set_module_property DISPLAY_NAME "SV 10GBase-R Transiver"
set_module_property TOP_LEVEL_HDL_FILE sv_10gbaser_xcvr.v
set_module_property TOP_LEVEL_HDL_MODULE sv_10gbaser_xcvr
set_module_property INSTANTIATE_IN_SYSTEM_MODULE true
set_module_property EDITABLE true
#set_module_property SIMULATION_MODEL_IN_VERILOG 1           
set_module_property EDITABLE true
# | 
# +-----------------------------------

# +-----------------------------------
# | files
# | 
add_file sv_10gbaser_xcvr.v {SYNTHESIS SIMULATION}

add_file ./sv_10gbaser_tx_ch.v {SYNTHESIS SIMULATION}
add_file ./sv_10gbaser_rx_ch.v {SYNTHESIS SIMULATION}
add_file ./sv_10gbaser_ch.v {SYNTHESIS SIMULATION}
add_file ./tx_10g_pll.v {SYNTHESIS SIMULATION}

add_file ../siv/csr_pcs10gbaser.sv {SYNTHESIS SIMULATION}
add_file ../siv/csr_pcs10gbaser_h.sv {SYNTHESIS SIMULATION}

add_file ./../../altera_xcvr_generic/sv/sv_tx_10g_pcs.v {SYNTHESIS SIMULATION}
add_file ./../../altera_xcvr_generic/sv/sv_rx_10g_pcs.v {SYNTHESIS SIMULATION}
add_file ./../../altera_xcvr_generic/sv/sv_tx_pma.v {SYNTHESIS SIMULATION}
add_file ./../../altera_xcvr_generic/sv/sv_rx_pma.v {SYNTHESIS SIMULATION}
add_file ./../../altera_xcvr_generic/sv/sv_tx_pma_ch.v {SYNTHESIS SIMULATION}

add_file ./../../altera_xcvr_generic/sv/sv_generic_csr_h.sv {SYNTHESIS SIMULATION}
add_file ./../../altera_xcvr_generic/sv/sv_generic_csr.sv {SYNTHESIS SIMULATION}
add_file ./../../altera_xcvr_generic/sv/csr_selector.sv {SYNTHESIS SIMULATION}
add_file ./../../altera_xcvr_generic/altera_xcvr_functions.sv {SYNTHESIS SIMULATION}
add_file ./../../altera_xcvr_generic/alt_reset_ctrl_tgx_cdrauto.sv {SYNTHESIS SIMULATION}
add_file ./../../altera_xcvr_generic/alt_reset_ctrl_lego.sv {SYNTHESIS SIMULATION}

# | 
# +-----------------------------------
add_display_item "" "General Options" GROUP tab
add_display_item "" "Analog Options" GROUP tab


# +-----------------------------------
# | parameters
# | 
add_parameter num_channels INTEGER 1
set_parameter_property num_channels DEFAULT_VALUE 1
set_parameter_property num_channels DISPLAY_NAME "Number of Channels"
set_parameter_property num_channels UNITS ""
set_parameter_property num_channels ALLOWED_RANGES {1:32}
set_parameter_property num_channels DESCRIPTION "Number of Channels"
set_parameter_property num_channels DISPLAY_HINT ""
set_parameter_property num_channels AFFECTS_GENERATION true
set_parameter_property num_channels IS_HDL_PARAMETER true
add_display_item "General Options" num_channels PARAMETER

add_parameter operation_mode STRING duplex
set_parameter_property operation_mode DEFAULT_VALUE duplex
set_parameter_property operation_mode DISPLAY_NAME "Operation Mode"
set_parameter_property operation_mode UNITS ""
set_parameter_property operation_mode ALLOWED_RANGES {duplex tx_only rx_only}
set_parameter_property operation_mode DESCRIPTION "Operation Mode"
set_parameter_property operation_mode DISPLAY_HINT ""
set_parameter_property operation_mode AFFECTS_GENERATION true
set_parameter_property operation_mode IS_HDL_PARAMETER true
add_display_item "General Options" num_channels PARAMETER

add_parameter sys_clk_in_mhz INTEGER 50
set_parameter_property sys_clk_in_mhz DEFAULT_VALUE 50
set_parameter_property sys_clk_in_mhz DISPLAY_NAME "System Clock Frequence (MHz)"
set_parameter_property sys_clk_in_mhz UNITS ""
set_parameter_property sys_clk_in_mhz ALLOWED_RANGES {30:150}
set_parameter_property sys_clk_in_mhz DESCRIPTION "System Clock Frequence (MHz)"
set_parameter_property sys_clk_in_mhz DISPLAY_HINT ""
set_parameter_property sys_clk_in_mhz AFFECTS_GENERATION true
set_parameter_property sys_clk_in_mhz IS_HDL_PARAMETER true
add_display_item "General Options" num_channels PARAMETER

add_parameter reconfig_interfaces INTEGER 1
set_parameter_property reconfig_interfaces DEFAULT_VALUE 1
set_parameter_property reconfig_interfaces DISPLAY_NAME "Number of Reconfig Interface"
set_parameter_property reconfig_interfaces UNITS ""
set_parameter_property reconfig_interfaces ALLOWED_RANGES {1:10}
set_parameter_property reconfig_interfaces DESCRIPTION "Number of Reconfig Interface"
set_parameter_property reconfig_interfaces DISPLAY_HINT ""
set_parameter_property reconfig_interfaces AFFECTS_GENERATION true
set_parameter_property reconfig_interfaces IS_HDL_PARAMETER true
add_display_item "General Options" num_channels PARAMETER

add_parameter ref_clk_freq STRING "644.53125 MHz"
set_parameter_property ref_clk_freq DEFAULT_VALUE "644.53125 MHz"
set_parameter_property ref_clk_freq DISPLAY_NAME "Reference Clock Frequency"
set_parameter_property ref_clk_freq UNITS ""
set_parameter_property ref_clk_freq ALLOWED_RANGES {"322.265625 Mhz" "644.53125 MHz"}
set_parameter_property ref_clk_freq DESCRIPTION "Reference Clock Frequency"
set_parameter_property ref_clk_freq DISPLAY_HINT ""
set_parameter_property ref_clk_freq AFFECTS_GENERATION true
set_parameter_property ref_clk_freq IS_HDL_PARAMETER true
add_display_item "General Options" num_channels PARAMETER

add_parameter gui_control_pin_out boolean 0
set_parameter_property gui_control_pin_out DEFAULT_VALUE 0
set_parameter_property gui_control_pin_out DISPLAY_NAME "Additional Control Pins Out"
set_parameter_property gui_control_pin_out UNITS ""
set_parameter_property gui_control_pin_out DESCRIPTION "Additional Control Pins Out"
set_parameter_property gui_control_pin_out DISPLAY_HINT ""
set_parameter_property gui_control_pin_out AFFECTS_GENERATION true
set_parameter_property gui_control_pin_out IS_HDL_PARAMETER true
add_display_item "Additional Options" gui_control_pin_out PARAMETER
# | 
# +-----------------------------------

# +-----------------------------------
# | connection point mgmt_clk
# | 
add_interface mgmt_clk clock end

set_interface_property mgmt_clk ENABLED true

add_interface_port mgmt_clk mgmt_clk clk Input 1
add_interface_port mgmt_clk mgmt_clk_rstn reset Input 1
# | 
# +-----------------------------------

# +-----------------------------------
# | connection point mgmt
# | 
add_interface mgmt avalon end
set_interface_property mgmt addressAlignment DYNAMIC
set_interface_property mgmt burstOnBurstBoundariesOnly false
set_interface_property mgmt explicitAddressSpan 0
set_interface_property mgmt holdTime 0
set_interface_property mgmt isMemoryDevice false
set_interface_property mgmt isNonVolatileStorage false
set_interface_property mgmt linewrapBursts false
set_interface_property mgmt maximumPendingReadTransactions 0
set_interface_property mgmt printableDevice false
set_interface_property mgmt readLatency 0
set_interface_property mgmt readWaitTime 0
set_interface_property mgmt setupTime 0
set_interface_property mgmt timingUnits Cycles
set_interface_property mgmt writeWaitTime 0
set_interface_property mgmt addressUnits SYMBOLS

set_interface_property mgmt ASSOCIATED_CLOCK mgmt_clk
set_interface_property mgmt ENABLED true

add_interface_port mgmt mgmt_read read Input 1
add_interface_port mgmt mgmt_write write Input 1
add_interface_port mgmt mgmt_writedata writedata Input 32
add_interface_port mgmt mgmt_readdata readdata Output 32
add_interface_port mgmt mgmt_address address Input 8
add_interface_port mgmt mgmt_waitrequest waitrequest Output 1
# | 
# +-----------------------------------

# +-----------------------------------
# | connection point xgmii_rx_clk
# | 
add_interface xgmii_rx_clk clock start
set_interface_property xgmii_rx_clk ENABLED true
add_interface_port xgmii_rx_clk xgmii_rx_clk clk Output 1
# +-----------------------------------

# +-----------------------------------
# | connection point pll_ref_clk
# | 
add_interface pll_ref_clk clock end

set_interface_property pll_ref_clk ENABLED true

add_interface_port pll_ref_clk pll_ref_clk clk Input 1
# | 
# +-----------------------------------

# +-----------------------------------
# | connection point rx_oc_busy 
# | 
add_interface rx_oc_busy conduit end
set_interface_property rx_oc_busy ENABLED true
set_interface_property rx_oc_busy EXPORT_OF true
add_interface_port rx_oc_busy rx_oc_busy export Input 1
# | 
# +-----------------------------------



set_module_property ELABORATION_CALLBACK elaboration_callback
#set_module_property GENERATION_CALLBACK generation_callback

#source ../../sopc_builder_ip/altera_avalon_mega_common/ipcc_wrap_split.tcl

proc elaboration_callback { } {
	# declare ports and mappings for elaboration callback
    	interface_ports_and_mapping elaboration

	# common code function to declare interface ports from mapping data
	#ipcc_elaboration_declarations
}

# declare dynamic interfaces and ports.
#	flag == elaboration means real interfaces and ports must be declared
#	flag == mapping_only declares no interfaces or ports, and returns the mapping data
#	        to map from HDL ports to interfaces
proc interface_ports_and_mapping { flag } {

	set hdl_module sv_10gbaser_xcvr
	#ipcc_set_module $hdl_module
	#ipcc_init_mappings $flag
	set num_chs [get_parameter_value num_channels]
	set op_mode [get_parameter_value operation_mode]
	set ctrl_out [get_parameter_value gui_control_pin_out]
	if { $op_mode == "rx_only" } {
		set tx_sup 0
	} else {
		set tx_sup 1
	}
	if { $op_mode == "tx_only" } {
		set rx_sup 0
	} else {
		set rx_sup 1
	}
	 if { $ctrl_out } {
	       if { $flag == "elaboration" } {
	         my_add_st_optional_interface pcs_status start xgmii_rx_clk  $num_chs  true
	         add_interface_port pcs_status pcs_status data Output $num_chs

	         my_add_st_optional_interface block_lock start xgmii_rx_clk  $num_chs  true
	         add_interface_port block_lock block_lock data Output $num_chs

	         my_add_st_optional_interface hi_ber start xgmii_rx_clk  $num_chs  true
	         add_interface_port hi_ber hi_ber data Output $num_chs
		}
       
	   } else {
	      my_terminate_port pcs_status 0 output
	      my_terminate_port block_lock 0 output
	      my_terminate_port hi_ber 0 output
	   }

	 if { $tx_sup } {
	       if { $flag == "elaboration" } {
	         # declare calibration tx interface and port
	         my_add_st_optional_interface tx_ready start mgmt_clk  1 true
	         add_interface_port tx_ready tx_ready data Output 1
        
		 add_interface xgmii_tx_clk clock end
		 set_interface_property xgmii_tx_clk ENABLED true
		 add_interface_port xgmii_tx_clk xgmii_tx_clk clk Input 1
		 }
	   } else {
	      # terminate calibration ports inside the wrapper
	      my_terminate_port tx_ready 0 output
	      my_terminate_port xgmii_tx_clk 0 input
	   }

	  if { $rx_sup } {
	       if { $flag == "elaboration" } {
	         # declare calibration rx interface and port
	         my_add_st_optional_interface rx_ready start mgmt_clk  1 true
	         add_interface_port rx_ready rx_ready data Output 1
	      }
	   } else {
	      # terminate calibration ports inside the wrapper
	      my_terminate_port rx_ready 0 output
	   }

	if { $tx_sup } {
	  for { set i 0 } { $i < $num_chs } {incr i} {
		if { $flag == "elaboration" } {
		 
			#xgmii_tx_dc
			my_add_st_optional_interface xgmii_tx_dc_$i end xgmii_tx_clk 72 true
			
			#tx_serial_data
			add_interface tx_serial_data_$i conduit start
			set_interface_property tx_serial_data_$i ENABLED true
			set_interface_property tx_serial_data_$i EXPORT_OF true
		                
		  }	
		# the HDL-to-interface mapping
		add_interface_port tx_serial_data_$i tx_serial_data_$i export Output 1
		set_port_property tx_serial_data_$i FRAGMENT_LIST [list tx_serial_data@$i ]
		add_interface_port xgmii_tx_dc_$i xgmii_tx_dc_$i data Input 72
		set_port_property xgmii_tx_dc_$i FRAGMENT_LIST [list xgmii_tx_dc@[expr [expr $i + 1] * 72 - 1]:[expr $i * 72] ]
		#ipcc_add_interface_mapped_port tx_serial_data_$i tx_serial_data@$i export Output $num_chs
		#ipcc_add_interface_mapped_port xgmii_tx_dc_$i xgmii_tx_dc@[expr [expr $i + 1] * 72 - 1]:[expr $i * 72] data Input [expr $num_chs * 72]
		}
	} else {
	      my_terminate_port tx_serial_data 0 output
	      my_terminate_port xgmii_tx_dc 0 input
	}
	
	if { $rx_sup } {
	  for { set i 0 } { $i < $num_chs } {incr i} {
		if { $flag == "elaboration" } {
		 
			#xgmii_rx_dc
			my_add_st_optional_interface xgmii_rx_dc_$i start xgmii_tx_clk 72 true
			
			#tx_serial_data
			add_interface rx_serial_data_$i conduit end
			set_interface_property rx_serial_data_$i ENABLED true
			set_interface_property rx_serial_data_$i EXPORT_OF true
		                
		  }	
		# the HDL-to-interface mapping
		add_interface_port rx_serial_data_$i rx_serial_data_$i export Input 1
		set_port_property rx_serial_data_$i FRAGMENT_LIST [list rx_serial_data@$i ]
		add_interface_port xgmii_rx_dc_$i xgmii_rx_dc_$i data Output 72
		set_port_property xgmii_rx_dc_$i FRAGMENT_LIST [list xgmii_rx_dc@[expr [expr $i + 1] * 72 - 1]:[expr $i * 72] ]
		#ipcc_add_interface_mapped_port rx_serial_data_$i rx_serial_data@$i export Input $num_chs
		#ipcc_add_interface_mapped_port xgmii_rx_dc_$i xgmii_rx_dc@[expr [expr $i + 1] * 72 - 1]:[expr $i * 72] data Output [expr $num_chs * 72]
	   }
	} else {
	      my_terminate_port rx_serial_data 0 output
	      my_terminate_port xgmii_rx_dc 0 input
	}
}

proc generation_callback { } {
	# declare ports and mappings for generation callback
    #interface_ports_and_mapping generation
    #ipcc_set_module alt_pma_controller

	# common code function to generate HDL wrapper from static ports & parameters, and mapping data
	#set hdl_file [ipcc_generate_hdl_wrapper]
	#send_message info "add_file $hdl_file {SIMULATION SYNTHESIS}"
	#add_file $hdl_file {SIMULATION SYNTHESIS}
}


proc my_add_st_optional_interface { if_name if_dir if_clock width used } {
	add_interface $if_name avalon_streaming $if_dir
	set_interface_property $if_name dataBitsPerSymbol $width
	set_interface_property $if_name maxChannel 0
	set_interface_property $if_name readyLatency 0
	set_interface_property $if_name symbolsPerBeat 1
	if { $used } {
         	set_interface_property $if_name ENABLED true
		set_interface_property $if_name ASSOCIATED_CLOCK $if_clock
	} else {
        	set_interface_property $if_name ENABLED false
	}
}

proc my_terminate_port { port_name termination_value direction } {
	#ipcc_set_port_termination $port_name $termination_value $direction

}